/*  SIM2.PRG */

library pgraph;

rep=500000;
theta= .6;
let ns = 50 200;
let ks = 4 8;

dfcrit=-3.41;
m=21;
cs=-rev(seqa(0,1,m));

graphset;
pqgwin many;
_pdate="";
_plwidth=6;
let _pmcolor = 0 0 0 0 0 0 0 0 15;
fonts("complex simgrma");
_pcolor=1;
_protate=1;
let _pltype = 3 4 6;
xtics(-20,0,4,4);
_paxht=.3;


begwind;
window(2,2,0);
makewind(6.855,9,0,0,1);
setwind(1);

for ki (1,rows(ks),1);
k=ks[ki];
for ni (1,rows(ns),1);
n=ns[ni];

store=zeros(m,3);
for di (1,m,1);

c=cs[di];
if k>0;
  a=-((-theta).^seqa(1,1,k));
  a0=c*(1-sumc(a))/n;
else;
  a0=c/n;
endif;

stat=zeros(rep,3);
for i (1,rep,1);

e=rndn(n+k+1,1);
y=zeros(n+k+1,1);
y[1:k+1]=e[1:k+1];
for t (k+2,n+k+1,1);
 y[t]=(1+a0)*y[t-1]+e[t];
 if k>0;
   y[t]=y[t]+a'rev(y[t-k:t-1]-y[t-k-1:t-2]);
 endif;
endfor;
dy=y[k+2:n+k+1]-y[k+1:n+k];
x0=ones(n,1);
if k>0;
 for j (1,k,1);
  x0=x0~(y[k+2-j:n+k+1-j]-y[k+1-j:n+k-j]);
 endfor;
endif;
x1=y[k+1:n+k]~seqa(1,1,n)~x0;
x0f=1;
if k>0;
 x0f=x0f~dy[n];
 if k>1;
   x0f=x0f~x0[n,2:k];
 endif;
endif;
x1f=y[n+k+1]~(n+1)~x0f;
mu=y[n+k+1]*a0;
if k>0;
 mu=mu+x0f[2:k+1]*a;
endif;

beta0=dy/x0;
mu0=x0f*beta0;
e0=dy-x0*beta0;
sig0=(e0'e0)/n;

xxi=invpd(moment(x1,0));
beta1=xxi*(x1'dy);
mu1=x1f*beta1;
e1=dy-x1*beta1;
sig1=(e1'e1)/n;
adf=beta1[1]/sqrt(xxi[1,1]*sig1);
fc=beta1[1 2]'invpd(xxi[1 2,1 2])*beta1[1 2]/sig1;
mdf=mu1.*(adf.<dfcrit)+mu0.*(adf.>=dfcrit);

if fc>2; w=1-2/fc; else; w=0; endif;
mua=mu1.*w+mu0.*(1-w);

stat[i,1]=mu1-mu;
stat[i,2]=mdf-mu;
stat[i,3]=mua-mu;

endfor;

store[di,.]=n*meanc(stat.^2)';

endfor;

kn=ftocv(k,1,0);
tt="" $+ "n=" $+ ftocv(n,1,0) $+ ", k=" $+ kn;
xlabel(tt);
_plegctl = 1~5~(-20)~(1+k);
_plegstr="Unconstrained\000Pre-Test\000Averaging";
ytics(1+k,10+k,1,1);

xy(cs,store);
nextwind;
endfor;
endfor;

_paxes = 0;
xlabel("");
let _pmsgctl[1,7] = 
1 8.75 .2 0 2 1 0 ;
ps= "" $+ "Figure 4: Finite Sample Forecast Risk, \202Q\201=" $+ ftocv(theta,1,1);
_pmsgstr = ps;

draw;
endwind;

