/*  SIM3.PRG */

library pgraph;

rep=500000;
let thetas= .6;
let ns = 50 200;
let ks = 4 8 12;

dfcrit=-3.41;
m=21;
cs=-rev(seqa(0,1,m));

for thetai (1,rows(thetas),1);
theta=thetas[thetai];

graphset;
pqgwin many;
_pdate="";
_plwidth=6;
let _pmcolor = 0 0 0 0 0 0 0 0 15;
fonts("complex simgrma");
_pcolor=1;
_protate=1;
let _pltype = 6 3 2;
xtics(-20,0,4,4);
_paxht=.3;


begwind;
window(3,2,0);
makewind(6.855,9,0,0,1);
setwind(1);

for ki (1,rows(ks),1);
k=ks[ki];
for ni (1,rows(ns),1);
n=ns[ni];

store=zeros(m,3);
for di (1,m,1);

c=cs[di];
if k>0;
  a=-((-theta).^seqa(1,1,k));
  a0=c*(1-sumc(a))/n;
else;
  a0=c/n;
endif;

stat=zeros(rep,3);
for i (1,rep,1);

e=rndn(n+k+1,1);
y=zeros(n+k+1,1);
y[1:k+1]=e[1:k+1];
for t (k+2,n+k+1,1);
 y[t]=(1+a0)*y[t-1]+e[t];
 if k>0;
   y[t]=y[t]+a'rev(y[t-k:t-1]-y[t-k-1:t-2]);
 endif;
endfor;
dy=y[k+2:n+k+1]-y[k+1:n+k];
x0=ones(n,1);
if k>0;
 for j (1,k,1);
  x0=x0~(y[k+2-j:n+k+1-j]-y[k+1-j:n+k-j]);
 endfor;
endif;
x1=y[k+1:n+k]~seqa(1,1,n)~x0;

x0f=1;
if k>0;
 x0f=x0f~dy[n];
 if k>1;
   x0f=x0f~x0[n,2:k];
 endif;
endif;
x1f=y[n+k+1]~(n+1)~x0f;
mu=y[n+k+1]*a0;
if k>0;
 mu=mu+x0f[2:k+1]*a;
endif;


e0=zeros(n,(k+1));
e1=zeros(n,(k+1));
mu0=zeros(k+1,1);
mu1=zeros(k+1,1);
s0=x0'dy;
xx0=moment(x0,0);
s1=x1'dy;
xx1=moment(x1,0);
for j (0,k,1);
 betaj=s0[1:1+j]/xx0[1:1+j,1:1+j];
 mu0[j+1]=x0f[1:1+j]*betaj;
 e0[.,j+1]=dy-x0[.,1:1+j]*betaj;

 betaj=s1[1:3+j]/xx1[1:3+j,1:3+j];
 mu1[j+1]=x1f[1:3+j]*betaj;
 e1[.,j+1]=dy-x1[.,1:3+j]*betaj;
endfor;

for j (0,k,1);
endfor;

ej=e1[.,k+1];
sig=(ej'ej)/(n-k-3);
r1=seqa(2,1,k+1)*sig;
a1=moment(e1,0);
mallows1=diag(a1)+r1*2;
mu_1=mu1[minindc(mallows1)];

kk=(k+1);
alpha0=ones(kk,1)/kk;
{w1,u1,u2,u3,u4,ret}=QProg(alpha0,a1,-r1,ones(1,kk),1,0,0,(1e-20)~1);
mu_2=mu1'w1;


r=(seqa(0,1,k+1)|seqa(2,1,k+1))*sig;
kk=2*(k+1);
alpha0=ones(kk,1)/kk;
{wa,u1,u2,u3,u4,ret}=QProg(alpha0,moment(e0~e1,0),-r,ones(1,kk),1,0,0,(1e-20)~1);
mu_3=(mu0|mu1)'wa;


stat[i,1]=mu_1-mu;
stat[i,2]=mu_2-mu;
stat[i,3]=mu_3-mu;

endfor;

store[di,.]=n*meanc(stat.^2)';

endfor;

kn=ftocv(k,1,0);
tt="" $+ "n=" $+ ftocv(n,1,0) $+ ", K=" $+ kn;
xlabel(tt);
@_plegctl = 1~8~(-20)~7;@
_plegstr="Selection\000Partial Averaging\000General Averaging";
ymin=floor(minc(minc(store)));
ymax=ceil(maxc(maxc(store)));
ytics(ymin,ymax,1,1);
_plegctl = 1~8~(-20)~ymin;


xy(cs,store);
nextwind;
endfor;
endfor;

_paxes = 0;
xlabel("");
let _pmsgctl[1,7] = 
1 8.75 0.18 0 2 1 0 ;
ps= "" $+ "Figure 5: Selection and Averaging over k";
_pmsgstr = ps;

draw;
endwind;

endfor;